<?php

declare(strict_types=1);

namespace App\Scolarite\Domain\Event;

use App\Administration\Domain\Model\User\UserId;
use App\Scolarite\Domain\Model\Homework\HomeworkId;
use App\Scolarite\Domain\Model\HomeworkSubmission\HomeworkSubmissionId;
use App\Shared\Domain\DomainEvent;
use App\Shared\Domain\Tenant\TenantId;
use DateTimeImmutable;
use Override;
use Ramsey\Uuid\UuidInterface;

final readonly class DevoirRendu implements DomainEvent
{
    public function __construct(
        public HomeworkSubmissionId $submissionId,
        public HomeworkId $homeworkId,
        public UserId $studentId,
        public TenantId $tenantId,
        private DateTimeImmutable $occurredOn,
    ) {
    }

    #[Override]
    public function occurredOn(): DateTimeImmutable
    {
        return $this->occurredOn;
    }

    #[Override]
    public function aggregateId(): UuidInterface
    {
        return $this->submissionId->value;
    }
}
